from oslo_serialization import jsonutils
from nova.scheduler import weights

from nova.virt.hardware import calc_cells_weight_according_l2_topo

class NUMAWighter(weights.BaseHostWeigher):

    def weight_multiplier(self, host_state):
        """Override the weight multiplier."""

        return 1

    def _weigh_object(self, host_state, weight_properties):

        cpu_info = host_state.cpu_info
        cpu_model = jsonutils.loads(cpu_info).get("model") if cpu_info else None

        host_numa_topology = host_state.numa_topology
        host_cells = host_numa_topology.cells

        return calc_cells_weight_according_l2_topo(host_cells, cpu_model=cpu_model)

